      Program GetStat
	USE IMSL

c     Copyright: Junfeng Liu, Yale University School of Medicine, November-09-2004

	integer      nd
	parameter    (nd=20000)
	real         m,sd,x(nd,4),d1(nd),d2(nd)

      open(2,file='stat.txt',status='unknown')

	open(3,file='beta.txt',status='unknown',access='sequential',
     &       form='formatted')
           do i=1,nd
	        read(3,*)(x(i,k),k=1,4)
           end do
      close(3)
	
	do kk=1,4
         do i=1,nd
	      d1(i)=x(i,kk)
         end do
	   call svrgn(nd,d1,d2)
         m=0.0
	   do i=1,nd
	      m=m+d1(i)
	   end do
         m=m/(nd*1.0)
         sd=0.0
	   do i=1,nd
	      sd=sd+(d1(i)-m)**2
	   end do
         sd=sqrt(sd/(nd-1.0))
         write(2,100)m,sd,d2(int(0.025*nd)),d2(int(0.50*nd)),
     & 	             d2(int(0.975*nd))
      end do

	open(3,file='Delta-sigma2.txt',status='unknown',access='sequential',
     &       form='formatted')
           do i=1,nd
	        read(3,*)(x(i,k),k=1,2)
           end do
      close(3)
	
	do kk=1,2
         do i=1,nd
	      d1(i)=x(i,kk)
         end do
	   call svrgn(nd,d1,d2)
         m=0.0
	   do i=1,nd
	      m=m+d1(i)
	   end do
         m=m/(nd*1.0)
         sd=0.0
	   do i=1,nd
	      sd=sd+(d1(i)-m)**2
	   end do
         sd=sqrt(sd/(nd-1.0))
         write(2,100)m,sd,d2(int(0.025*nd)),d2(int(0.50*nd)),
     & 	             d2(int(0.975*nd))
      end do

	open(3,file='z.txt',status='unknown',access='sequential',
     &       form='formatted')
           do i=1,nd
	        read(3,*)(x(i,k),k=1,4)
           end do
      close(3)
	
	do kk=1,4
         do i=1,nd
	      d1(i)=x(i,kk)
         end do
	   call svrgn(nd,d1,d2)
         m=0.0
	   do i=1,nd
	      m=m+d1(i)
	   end do
         m=m/(nd*1.0)
         sd=0.0
	   do i=1,nd
	      sd=sd+(d1(i)-m)**2
	   end do
         sd=sqrt(sd/(nd-1.0))
         write(2,100)m,sd,d2(int(0.025*nd)),d2(int(0.50*nd)),
     & 	             d2(int(0.975*nd))
      end do


	open(3,file='epsilon.txt',status='unknown',access='sequential',
     &       form='formatted')
           do i=1,nd
	        read(3,*)(x(i,k),k=1,4)
           end do
      close(3)
	
	do kk=1,4
         do i=1,nd
	      d1(i)=x(i,kk)
         end do
	   call svrgn(nd,d1,d2)
         m=0.0
	   do i=1,nd
	      m=m+d1(i)
	   end do
         m=m/(nd*1.0)
         sd=0.0
	   do i=1,nd
	      sd=sd+(d1(i)-m)**2
	   end do
         sd=sqrt(sd/(nd-1.0))
         write(2,100)m,sd,d2(int(0.025*nd)),d2(int(0.50*nd)),
     & 	             d2(int(0.975*nd))
      end do

100   format(1x,' & ',f12.6,' & ',f12.6,' & ',f12.6,' & ',f12.6,
     &       ' & ',f12.6,'\\')

	close(2) 
      
	close(2) 
      
	end