      Program       Model_Selection_CPO_Conditional_prediction_Ordinate_Normal_Model
	USE           IMSL

c     Copyright: Junfeng Liu, Yale University School of Medicine, November-09-2004

      integer       nd,nc,p
	parameter     (nd=20000,nc=4,p=4)
	real          bet(nd,4),e(nd,4),z(nd,4),delta(nd),sigma(nd)
	integer       m(nc),n(nc,5),y(nc,5)
	real          x(nc,5,p),u,CPO(nc,5),w1,CPO_normal

	m(1)=5
	m(2)=3
	m(3)=5
	m(4)=3

      open(2,file='input.txt',status='old')
      do k=1,m(1)
	   read(2,*)(x(1,k,j),j=1,p),n(1,k),y(1,k) 
	end do
      do k=1,m(2)
	   read(2,*)(x(2,k,j),j=1,p),n(2,k),y(2,k) 
	end do
      do k=1,m(3)
	   read(2,*)(x(3,k,j),j=1,p),n(3,k),y(3,k) 
	end do
      do k=1,m(4)
	   read(2,*)(x(4,k,j),j=1,p),n(4,k),y(4,k) 
	end do
      close(2)

      open(2,file='beta.txt',status='unknown')
	do i=1,nd
	   read(2,*)(bet(i,j),j=1,4)
	end do
	close(2) 

c      open(2,file='delta.txt',status='unknown')
	do i=1,nd
c	   read(2,*)delta(i)
	   delta(i)=0.0
	end do
c	close(2) 

c      open(2,file='sigma.txt',status='unknown')
	do i=1,nd
c	   read(2,*)sigma(i)
	   sigma(i)=1.0
	end do
c	close(2) 

c	open(2,file='z.txt',status='unknown')
	do i=1,nd
	   do j=1,p
c	   read(2,*)(z(i,j),j=1,4)
	      z(i,j)=0.0
         end do
	end do
c	close(2) 

      open(2,file='epsilon.txt',status='unknown')
	do i=1,nd
	   do j=1,p
c	   read(2,*)(e(i,j),j=1,4)
	      e(i,j)=0.0
         end do
	end do
	close(2) 

	do i=1,nc
	   do j=1,5                 ! m(i)
            CPO(i,j)=0
	   end do
      end do

      do i=1,nc
	   do j=1,m(i)
	      do k=1,nd
	         w=0.0
		     do l=1,p
	            w=w+x(i,j,l)*bet(k,l)
		     end do 
	         u=delta(k)*z(k,i)+sigma(k)*e(k,i)
	         w=w+x(i,j,1)*u
	         CPO(i,j)=CPO(i,j)
     &			     +1.0/exp( y(i,j)*w-n(i,j)*log(1.0+exp(w))   
     &		         +facto(n(i,j),y(i,j)) )
	      end do
            CPO(i,j)=CPO(i,j)/nd
            CPO(i,j)=1.0/CPO(i,j)
	   end do
	end do
	    
      CPO_normal=0.0
	do i=1,nc
	   do j=1,m(i)
	      CPO_normal=CPO_normal+CPO(i,j)
	   end do
      end do
	    
      open(2,file='CPO_normal.txt',status='unknown')
	write(2,*)CPO_normal
	close(2) 

      end

      real function facto(n,y)
	integer y,n

      if(y.eq.0.or.y.eq.n)then
	   facto=1.0
	else 
         c1=0.0
   	   do k=1,n
	      c1=c1+log(k*1.0)
	   end do
         c2=0.0
	   do k=1,y
	      c2=c2+log(k*1.0)
	   end do
         c3=0.0
	   do k=1,n-y
	      c3=c3+log(k*1.0)
	   end do
	   facto=c1-c2-c3
      end if
      return 
	end
